3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
51 if test "$1" = "#unmatched"
58 # Print a submodule configuration setting
64 # Checks in the usual git-config places first (for overrides),
65 # otherwise it falls back on .gitmodules. This allows you to
66 # distribute project-wide defaults in .gitmodules, while still
67 # customizing individual repositories if necessary. If the option is
68 # not in .gitmodules either, print a default value.
70 get_submodule_config () {
74 value=$(git config submodule."$name"."$option")
77 value=$(git config -f .gitmodules submodule."$name"."$option")
79 printf '%s' "${value:-$default}"
84 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
87 # Sanitize the local git environment for use within a submodule. We
88 # can't simply use clear_local_git_env since we want to preserve some
89 # of the settings from GIT_CONFIG_PARAMETERS.
90 sanitize_submodule_env()
92 save_config=$GIT_CONFIG_PARAMETERS
94 GIT_CONFIG_PARAMETERS=$save_config
95 export GIT_CONFIG_PARAMETERS
99 # Add a new submodule to the working tree, .gitmodules and the index
103 # optional branch is stored in global branch variable
107 # parse $args after "submodule ... add".
113 case "$2" in '') usage ;; esac
124 case "$2" in '') usage ;; esac
129 reference_path="${1#--reference=}"
132 case "$2" in '') usage ;; esac
137 case "$2" in '') usage ;; esac
158 if test -n "$reference_path"
160 is_absolute_path "$reference_path" ||
161 reference_path="$wt_prefix$reference_path"
163 reference="--reference=$reference_path"
169 if test -z "$sm_path"; then
170 sm_path=$(printf '%s\n' "$repo" |
171 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
174 if test -z "$repo" || test -z "$sm_path"; then
178 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
180 # assure repo is absolute or relative to parent
183 test -z "$wt_prefix" ||
184 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
186 # dereference source url relative to parent's url
187 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
194 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
199 # multiple //; leading ./; /./; /../; trailing /
200 sm_path=$(printf '%s/\n' "$sm_path" |
210 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211 die "$(eval_gettext "'\$sm_path' already exists in the index")"
213 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
215 eval_gettextln "The following path is ignored by one of your .gitignore files:
217 Use -f if you really want to add it." >&2
221 if test -n "$custom_name"
223 sm_name="$custom_name"
228 # perhaps the path exists and is already a git repo, else clone it
229 if test -e "$sm_path"
231 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
233 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
235 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
239 if test -d ".git/modules/$sm_name"
243 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
244 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
245 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
246 echo >&2 " $realrepo"
247 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
248 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
250 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
253 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
255 sanitize_submodule_env
257 # ash fails to wordsplit ${branch:+-b "$branch"...}
259 '') git checkout -f -q ;;
260 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
262 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
264 git config submodule."$sm_name".url "$realrepo"
266 git add $force "$sm_path" ||
267 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
269 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
270 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
273 git config -f .gitmodules submodule."$sm_name".branch "$branch"
275 git add --force .gitmodules ||
276 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
280 # Execute an arbitrary command sequence in each checked out
283 # $@ = command to execute
287 # parse $args after "submodule ... foreach".
309 # dup stdin so that it can be restored when running the external
310 # command in the subshell (and a recursive call to this function)
314 git submodule--helper list --prefix "$wt_prefix" ||
317 while read mode sha1 stage sm_path
319 die_if_unmatched "$mode"
320 if test -e "$sm_path"/.git
322 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
323 say "$(eval_gettext "Entering '\$displaypath'")"
324 name=$(git submodule--helper name "$sm_path")
326 prefix="$prefix$sm_path/"
327 sanitize_submodule_env
329 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
330 # we make $path available to scripts ...
338 if test -n "$recursive"
340 cmd_foreach "--recursive" "$@"
343 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
349 # Register submodules in .git/config
351 # $@ = requested paths (default to all)
355 # parse $args after "submodule ... init".
376 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
380 # Unregister submodules from .git/config and remove their work tree
382 # $@ = requested paths (use '.' to deinit all submodules)
386 # parse $args after "submodule ... deinit".
414 if test -n "$deinit_all" && test "$#" -ne 0
416 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
419 if test $# = 0 && test -z "$deinit_all"
421 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
425 git submodule--helper list --prefix "$wt_prefix" "$@" ||
428 while read mode sha1 stage sm_path
430 die_if_unmatched "$mode"
431 name=$(git submodule--helper name "$sm_path") || exit
433 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
435 # Remove the submodule work tree (unless the user already did it)
436 if test -d "$sm_path"
438 # Protect submodules containing a .git directory
439 if test -d "$sm_path/.git"
441 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
442 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
447 git rm -qn "$sm_path" ||
448 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
451 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
452 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
455 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
457 # Remove the .git/config entries (unless the user already did it)
458 if test -n "$(git config --get-regexp submodule."$name\.")"
460 # Remove the whole section so we have a clean state when
461 # the user later decides to init this submodule again
462 url=$(git config submodule."$name".url)
463 git config --remove-section submodule."$name" 2>/dev/null &&
464 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
469 is_tip_reachable () (
470 sanitize_submodule_env &&
472 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
476 fetch_in_submodule () (
477 sanitize_submodule_env &&
483 git fetch $(get_default_remote) "$2" ;;
488 # Update each submodule path to correct revision, using clone and checkout as needed
490 # $@ = requested paths (default to all)
494 # parse $args after "submodule ... update".
517 case "$2" in '') usage ;; esac
518 reference="--reference=$2"
534 recommend_shallow="--recommend-shallow"
536 --no-recommend-shallow)
537 recommend_shallow="--no-recommend-shallow"
540 case "$2" in '') usage ;; esac
548 case "$2" in '') usage ;; esac
571 cmd_init "--" "$@" || return
575 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
576 ${wt_prefix:+--prefix "$wt_prefix"} \
577 ${prefix:+--recursive-prefix "$prefix"} \
578 ${update:+--update "$update"} \
579 ${reference:+--reference "$reference"} \
580 ${depth:+--depth "$depth"} \
581 ${recommend_shallow:+"$recommend_shallow"} \
583 "$@" || echo "#unmatched"
586 while read mode sha1 stage just_cloned sm_path
588 die_if_unmatched "$mode"
590 name=$(git submodule--helper name "$sm_path") || exit
591 url=$(git config submodule."$name".url)
592 branch=$(get_submodule_config "$name" branch master)
593 if ! test -z "$update"
595 update_module=$update
597 update_module=$(git config submodule."$name".update)
598 if test -z "$update_module"
600 update_module="checkout"
604 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
606 if test $just_cloned -eq 1
609 update_module=checkout
611 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
612 git rev-parse --verify HEAD) ||
613 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
618 if test -z "$nofetch"
620 # Fetch remote before determining tracking $sha1
621 fetch_in_submodule "$sm_path" ||
622 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
624 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
625 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
626 git rev-parse --verify "${remote_name}/${branch}") ||
627 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
630 if test "$subsha1" != "$sha1" || test -n "$force"
633 # If we don't already have a -f flag and the submodule has never been checked out
634 if test -z "$subsha1" && test -z "$force"
639 if test -z "$nofetch"
641 # Run fetch only if $sha1 isn't present or it
642 # is not reachable from a ref.
643 is_tip_reachable "$sm_path" "$sha1" ||
644 fetch_in_submodule "$sm_path" ||
645 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
647 # Now we tried the usual fetch, but $sha1 may
648 # not be reachable from any of the refs
649 is_tip_reachable "$sm_path" "$sha1" ||
650 fetch_in_submodule "$sm_path" "$sha1" ||
651 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
655 case "$update_module" in
657 command="git checkout $subforce -q"
658 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
659 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
663 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
664 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
665 must_die_on_failure=yes
669 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
670 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
671 must_die_on_failure=yes
674 command="${update_module#!}"
675 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
676 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
677 must_die_on_failure=yes
680 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
683 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
686 elif test -n "$must_die_on_failure"
688 die_with_status 2 "$die_msg"
690 err="${err};$die_msg"
695 if test -n "$recursive"
698 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
700 sanitize_submodule_env
707 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
710 err="${err};$die_msg"
713 die_with_status $res "$die_msg"
738 sanitize_submodule_env
740 git describe "$2" 2>/dev/null ||
741 git describe --tags "$2" 2>/dev/null ||
742 git describe --contains "$2" 2>/dev/null ||
743 git describe --all --always "$2"
746 test -z "$revname" || revname=" ($revname)"
749 # Show commit summary for submodules in index or working tree
751 # If '--cached' is given, show summary between index and given commit,
752 # or between working tree and given commit
754 # $@ = [commit (default 'HEAD'),] requested paths (default all)
761 # parse $args after "submodule ... summary".
776 isnumber "$summary_limit" || usage
780 summary_limit="${1#--summary-limit=}"
781 isnumber "$summary_limit" || usage
797 test $summary_limit = 0 && return
799 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
803 elif test -z "$1" || test "$1" = "HEAD"
805 # before the first commit: compare with an empty tree
806 head=$(git hash-object -w -t tree --stdin </dev/null)
807 test -z "$1" || shift
815 die "$(gettext "The --cached option cannot be used with the --files option")"
821 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
822 # Get modified modules cared by user
823 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
824 sane_egrep '^:([0-7]* )?160000' |
825 while read mod_src mod_dst sha1_src sha1_dst status sm_path
827 # Always show modules deleted or type-changed (blob<->module)
828 if test "$status" = D || test "$status" = T
830 printf '%s\n' "$sm_path"
833 # Respect the ignore setting for --for-status.
834 if test -n "$for_status"
836 name=$(git submodule--helper name "$sm_path")
837 ignore_config=$(get_submodule_config "$name" ignore none)
838 test $status != A && test $ignore_config = all && continue
840 # Also show added or modified modules which are checked out
841 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
842 printf '%s\n' "$sm_path"
846 test -z "$modules" && return
848 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
849 sane_egrep '^:([0-7]* )?160000' |
851 while read mod_src mod_dst sha1_src sha1_dst status name
853 if test -z "$cached" &&
854 test $sha1_dst = 0000000000000000000000000000000000000000
858 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
860 100644 | 100755 | 120000)
861 sha1_dst=$(git hash-object $name)
867 eval_gettextln "unexpected mode \$mod_dst" >&2
874 test $mod_src = 160000 &&
875 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
878 test $mod_dst = 160000 &&
879 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
882 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
885 case "$missing_src,$missing_dst" in
887 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
890 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
893 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
898 if test $mod_src = 160000 && test $mod_dst = 160000
900 range="$sha1_src...$sha1_dst"
901 elif test $mod_src = 160000
907 GIT_DIR="$name/.git" \
908 git rev-list --first-parent $range -- | wc -l
910 total_commits=" ($(($total_commits + 0)))"
914 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
915 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
918 blob="$(gettext "blob")"
919 submodule="$(gettext "submodule")"
920 if test $mod_dst = 160000
922 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
924 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
927 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
931 # Don't give error msg for modification whose dst is not submodule
932 # i.e. deleted or changed to blob
933 test $mod_dst = 160000 && echo "$errmsg"
935 if test $mod_src = 160000 && test $mod_dst = 160000
938 test $summary_limit -gt 0 && limit="-$summary_limit"
939 GIT_DIR="$name/.git" \
940 git log $limit --pretty='format: %m %s' \
941 --first-parent $sha1_src...$sha1_dst
942 elif test $mod_dst = 160000
944 GIT_DIR="$name/.git" \
945 git log --pretty='format: > %s' -1 $sha1_dst
947 GIT_DIR="$name/.git" \
948 git log --pretty='format: < %s' -1 $sha1_src
956 # List all submodules, prefixed with:
957 # - submodule not initialized
958 # + different revision checked out
960 # If --cached was specified the revision in the index will be printed
961 # instead of the currently checked out revision.
963 # $@ = requested paths (default to all)
967 # parse $args after "submodule ... status".
995 git submodule--helper list --prefix "$wt_prefix" "$@" ||
998 while read mode sha1 stage sm_path
1000 die_if_unmatched "$mode"
1001 name=$(git submodule--helper name "$sm_path") || exit
1002 url=$(git config submodule."$name".url)
1003 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1004 if test "$stage" = U
1006 say "U$sha1 $displaypath"
1009 if test -z "$url" ||
1011 ! test -d "$sm_path"/.git &&
1012 ! test -f "$sm_path"/.git
1015 say "-$sha1 $displaypath"
1018 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1020 set_name_rev "$sm_path" "$sha1"
1021 say " $sha1 $displaypath$revname"
1023 if test -z "$cached"
1025 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1027 set_name_rev "$sm_path" "$sha1"
1028 say "+$sha1 $displaypath$revname"
1031 if test -n "$recursive"
1034 prefix="$displaypath/"
1035 sanitize_submodule_env
1040 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1045 # Sync remote urls for submodules
1046 # This makes the value for remote.$remote.url match the value
1047 # specified in .gitmodules.
1076 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1079 while read mode sha1 stage sm_path
1081 die_if_unmatched "$mode"
1082 name=$(git submodule--helper name "$sm_path")
1083 url=$(git config -f .gitmodules --get submodule."$name".url)
1085 # Possibly a url relative to parent
1088 # rewrite foo/bar as ../.. to find path from
1089 # submodule work tree to superproject work tree
1090 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1091 # guarantee a trailing /
1092 up_path=${up_path%/}/ &&
1093 # path from submodule work tree to submodule origin repo
1094 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1095 # path from superproject work tree to submodule origin repo
1096 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1099 sub_origin_url="$url"
1100 super_config_url="$url"
1104 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1106 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1107 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1108 git config submodule."$name".url "$super_config_url"
1110 if test -e "$sm_path"/.git
1113 sanitize_submodule_env
1115 remote=$(get_default_remote)
1116 git config remote."$remote".url "$sub_origin_url"
1118 if test -n "$recursive"
1120 prefix="$prefix$sm_path/"
1129 # This loop parses the command line arguments to find the
1130 # subcommand name to dispatch. Parsing of the subcommand specific
1131 # options are primarily done by the subcommand implementations.
1132 # Subcommand specific options such as --branch and --cached are
1133 # parsed here as well, for backward compatibility.
1135 while test $# != 0 && test -z "$command"
1138 add | foreach | init | deinit | update | status | summary | sync)
1168 # No command word defaults to "status"
1169 if test -z "$command"
1179 # "-b branch" is accepted only by "add"
1180 if test -n "$branch" && test "$command" != add
1185 # "--cached" is accepted only by "status" and "summary"
1186 if test -n "$cached" && test "$command" != status && test "$command" != summary